//+------------------------------------------------------------------+
//|                                                   DoubleRect.mq4 |
//|                                              Copyright 2016, AM2 |
//|                                      http://www.forexsystems.biz |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, AM2"
#property link      "http://www.forexsystems.biz"
#property version   "1.00"
#property strict
#property indicator_chart_window

input string Music="News.wav";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   PutRect("R1",Time[0],Bid+5*Point,Time[5],Bid+15*Point,clrRed);
   PutRect("R2",Time[0],Bid-5*Point,Time[5],Bid-15*Point,clrBlue);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void PutRect(string name,datetime t1,double p1,datetime t2,double p2,color clr)
  {
   ObjectDelete(0,name);
//--- создадим прямоугольник по заданным координатам
   ObjectCreate(0,name,OBJ_RECTANGLE,0,t1,p1,t2,p2);
//--- установим цвет прямоугольника
   ObjectSetInteger(0,name,OBJPROP_COLOR,clr);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   if(Bid>ObjectGet("R1",OBJPROP_PRICE1) && Bid<ObjectGet("R1",OBJPROP_PRICE2))
     {
      PlaySound(Music);
      ObjectSetInteger(0,"R1",OBJPROP_COLOR,clrMagenta);
     }

   if(Bid<ObjectGet("R2",OBJPROP_PRICE1) && Bid>ObjectGet("R2",OBJPROP_PRICE2))
     {
      PlaySound(Music);
      ObjectSetInteger(0,"R2",OBJPROP_COLOR,clrDodgerBlue);
     }
     
   Comment("\n R1 Time1: ",ObjectGet("R1",OBJPROP_TIME1),
           "\n R1 Time2: ",ObjectGet("R1",OBJPROP_TIME2),
           "\n R1 Price1: ",ObjectGet("R1",OBJPROP_PRICE1),
           "\n R1 Price2: ",ObjectGet("R1",OBJPROP_PRICE2),
           "\n  ",
           "\n R2 Time1: ",ObjectGet("R2",OBJPROP_TIME1),
           "\n R2 Time2: ",ObjectGet("R2",OBJPROP_TIME2),
           "\n R2 Price1: ",ObjectGet("R2",OBJPROP_PRICE1),
           "\n R2 Price2: ",ObjectGet("R2",OBJPROP_PRICE2));
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
