//+------------------------------------------------------------------+
//|                                            Next Candle Range.mq4 |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   

   static int currentCandle;
   int lastCandle = Time[1]; 
   static bool linesDrawn = false;
   
   
   double lineH = ( Close[1] - Low[1] ) + ( (Close[1] + Low[1] + High[1]) / 3 );
   lineH = MathAbs(lineH);
      
   double lineL = ( ( Close[1] + Low[1] + High[1]) / 3 ) - (High[1] - Close[1]);
   lineL = MathAbs(lineL);
   
   
   
   if(currentCandle == lastCandle && linesDrawn == true){
      // Reset
      linesDrawn = false;
   }
   
   if(linesDrawn == false){
   
      
   
      if(ObjectFind(0, "HLineH") >= 0){
         ObjectDelete(0, "HLineH");
      }
      if(ObjectFind(0, "HLineL") >= 0){
         ObjectDelete(0, "HLineL");
      }
      
      
   
      ObjectCreate(0, "HLineH", OBJ_HLINE, 0, Time[0], lineH);
      ObjectSet("HLineH", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("HLineH", OBJPROP_COLOR, clrDeepSkyBlue);
      ObjectCreate(0, "HLineL", OBJ_HLINE, 0, Time[0], lineL);
      ObjectSet("HLineL", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("HLineL", OBJPROP_COLOR, clrDeepSkyBlue);
      
      linesDrawn = true;
      currentCandle = Time[0];
      
      
   }
   
   
   
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
  
  
  
  
  

  
  
  
  
  
//+------------------------------------------------------------------+
