//+------------------------------------------------------------------+
//|                                                   TrendSpeed.mq4 |
//|                                              Copyright 2016, AM2 |
//|                                      http://www.forexsystems.biz |
//+------------------------------------------------------------------+

// http://zakaz.opentraders.ru/33344.html


#property copyright "Copyright 2016, AM2"
#property link      "http://www.forexsystems.biz"
#property version   "1.00"
#property strict
#property indicator_chart_window

input int FontSise = 12;
input color FontColor = clrBlue;
input string FontName = "Arial";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void PutText(string text,double price,datetime time)
  {
   string name="Text"+(string)price;
//---   ""  
   ObjectCreate(0,name,OBJ_TEXT,0,time,price);
//---  
   ObjectSetString(0,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(0,name,OBJPROP_FONT,FontName);
//---   
   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,FontSise);
//---   
   ObjectSetInteger(0,name,OBJPROP_ANCHOR,ANCHOR_RIGHT_UPPER);
//---  
   ObjectSetInteger(0,name,OBJPROP_COLOR,FontColor);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int n1=0,n2=0;
   double p1=0,p2=0,speed=0;
   datetime t1=0,t2=0;

   for(int i=ObjectsTotal();i>=0;i--)
     {
      if(ObjectType(ObjectName(i))==OBJ_TREND)
        {
         p1 = ObjectGet(ObjectName(i),OBJPROP_PRICE1);
         p2 = ObjectGet(ObjectName(i),OBJPROP_PRICE2);
         t1 = (datetime)ObjectGet(ObjectName(i),OBJPROP_TIME1);
         t2 = (datetime)ObjectGet(ObjectName(i),OBJPROP_TIME2);
         n1 = iBarShift(NULL,0,t1);
         n2 = iBarShift(NULL,0,t2);

         speed=NormalizeDouble((p2-p1)/(Point*(n1-n2+0.0000001)),1); //     0. ( speed=NormalizeDouble((p2-p1)/(Point*(n1-n2)),1);) 
         PutText((string)speed,p2,t2);
        }
     }

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
